/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.base.management.core.utils;

import org.osgi.framework.Bundle;

public class BundleAwareManagedObjectImpl implements BundleAwareManagedObject {

	protected String bundleState;
	
	protected long bundleId;
	
	protected String bundleSymbolicName;

	@Override
	public String getBundleState() {
		return bundleState;
	}

	@Override
	public void setBundleState(String bundleState) {
		this.bundleState = bundleState;
	}

	@Override
	public long getBundleId() {
		return bundleId;
	}

	@Override
	public void setBundleId(long bundleId) {
		this.bundleId = bundleId;
	}

	@Override
	public String getBundleSymbolicName() {
		return bundleSymbolicName;
	}

	@Override
	public void setBundleSymbolicName(String bundleSymbolicName) {
		this.bundleSymbolicName = bundleSymbolicName;
	}
	
	@Override
	public BundleAwareManagedObject bundleState(String bundleState) {
		setBundleState(bundleState);
		return this;
	}

	@Override
	public BundleAwareManagedObject bundleState(int bundleState) {
		String bs = "UNKNOWN";
		switch (bundleState) {
		case Bundle.ACTIVE:
			bs = "Active";
			break;
		case Bundle.INSTALLED:
			bs = "Installed";
			break;
		case Bundle.RESOLVED:
			bs = "Resolved";
			break;
		case Bundle.STARTING:
			bs = "Starting";
			break;
		case Bundle.STOPPING:
			bs = "Stopping";
			break;
		case Bundle.UNINSTALLED:
			bs = "Uninstalled";
			break;
		}
		return this.bundleState(bs);
	}
	
	@Override
	public BundleAwareManagedObject bundleId(long bundleId) {
		setBundleId(bundleId);
		return this;
	}
	
	@Override
	public BundleAwareManagedObject bundleSymbolicName(String bundleSymbolicName) {
		setBundleSymbolicName(bundleSymbolicName);
		return this;
	}
	
}
